<?php
/*
Plugin Name: RP News Ticker
Plugin URI: http://www.rationalplanet.com/2010/07/rp-newsticker-plugin-for-wordpress/
Description: A versatile horizontal news ticker for sidebars using <a href="http://www.gcmingati.net/wordpress/wp-content/lab/jquery/newsticker/jq-liscroll/scrollanimate.html" target="_blank">liScroll</a>. A must-have. No setting, just visit the widgets section. Should be backward-compatible from 2.6+. Report bugs and submit ideas at <a href="http://www.rationalplanet.com/2010/07/rp-newsticker-plugin-for-wordpress/">the plugin's page</a>.
Version: 0.5
Author: Alexander Missa, offers@rationalplanet.com
Author URI: http://www.rationalplanet.com
License: GPLv2, http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
*/


/** 
 * @todo clear options on plugin uninstall
 * @todo allow set scroller speed
 * @todo allow header section
 * @todo allow format for scroller
 * @todo allow multiple instances of the widget
 * @todo allow periodical refresh with ajax
 * @todo appear effect 
 */

/**
 * Unified support for all RP plugins
 */
define('RATIONAL_ST_VERSION',   '0.4');
define('RATIONAL_ST_APP',   dirname(plugin_basename(__FILE__)));
define('RATIONAL_ST_PATH',  sprintf('%s%s%s', WP_PLUGIN_DIR, DIRECTORY_SEPARATOR, RATIONAL_ST_APP));
define('RATIONAL_ST_HTTP',  sprintf('%s/%s', WP_PLUGIN_URL, RATIONAL_ST_APP));

if(!function_exists('rp_compact_css')){
    function rp_compact_css($txt) {
        $txt = preg_replace ('/\'[^\'\\n\\r]*\'/', '', $txt);
        $txt = preg_replace ('/"[^"\\n\\r]*"/', '', $txt);
        $txt = preg_replace ('/\\/\\/[^\\n\\r]*[\\n\\r]/', '', $txt);
        $txt = preg_replace ('/\\/\\*[^*]*\\*+([^\\/][^*]*\\*+)*\\//', '', $txt);
        $txt = preg_replace('/^[ \t]*[\r\n]+/m', '', $txt);
        return $txt;
    }
}

function rpliscrollticker() {
    $options = get_option("widget_rpliscrollticker");
    $explicit = explode("\n", str_replace("\r", "", $options['explicitcontent'])) ;
        $categories = array();
        $in_config  = explode(',', $options['category_ids']);
        while($category = array_shift($in_config)){
            if(preg_match('/^[-]?[0-9]+$/', trim($category))){
                $categories[] = $category;
            }
        }
        //ob_start();fb($categories, '$categories'); ob_end_flush();
    $myposts = !empty($categories)
        ? get_posts(sprintf('numberposts=%d&category=%s', $options['post_limit'], implode(',', $categories)))
        : get_posts(sprintf('numberposts=%d', $options['post_limit']));
    $in_categories = array();
    global $post;
    foreach($myposts as $post){        
        setup_postdata($post);
        $in_categories[] = sprintf('<li><span>%s</span><a href="%s">%s</a></li>',
            apply_filters('the_time', get_the_time(__('jS F, Y G:i','rp-news-ticker')), __('jS F, Y G:i','rp-news-ticker')),
                apply_filters('the_permalink', get_permalink()), the_title('', '', false)
        );
    }
    $alldata = array();
    switch($options['usage_type']){
        case 2:
            $alldata = $in_categories;
            shuffle($alldata);
            break;
        case 3:
            $alldata = $explicit;
            break;
        case 4:
            $alldata = $explicit;
            shuffle($alldata);
            break;
        case 5:
            $alldata = array_merge($in_categories, $explicit);
            shuffle($alldata);
            break;
        case 6:
            $alldata = array_merge($in_categories, $explicit);
            break;
        case 7:
            $alldata = array_merge($explicit, $in_categories);
            break;
        default:
            $alldata = $in_categories;
            break;
    }
    if(empty($alldata)){
        return;
    }
    ?>
    <ul id="rpliscrollticker">                    
        <?php echo implode("\n", $alldata); ?>
    </ul>
    <?php
}

function widget_rpliscrollticker($args){
    extract($args);
    echo $before_widget;
    /*echo $before_title;
    _e('RP News Ticker','rpliscrollticker');
    echo $after_title;*/
    rpliscrollticker();
    echo $after_widget;
}

function rpliscrollticker_init() {
    wp_register_sidebar_widget('rp_liscroll_ticker', __('News Ticker (RP)','rp-news-ticker'), 'widget_rpliscrollticker', array());
    wp_register_widget_control('rp_liscroll_ticker', __('News Ticker (RP)','rp-news-ticker'), 'rpliscrollticker_control');
    wp_enqueue_script('liScroll', RATIONAL_ST_HTTP . '/liScroll.js', array('jquery'), RATIONAL_ST_VERSION, true);
    $locale_file = RATIONAL_ST_PATH . DIRECTORY_SEPARATOR . RATIONAL_ST_APP . '-' . get_locale() . '.mo';
    if (file_exists($locale_file)) {
        load_plugin_textdomain('rp-news-ticker', false, RATIONAL_ST_APP . DIRECTORY_SEPARATOR);
    }
    if(!is_admin()){
        add_action('wp_head'/*'admin_head'*/, 'rpliscrollticker_wp_head');
    }
}

function rpliscrollticker_control() {
    $css =<<<EOT
/* THE DIV IS ORIGINALLY HIDDEN TO SAVE THE LAYOUT WHEN JAVASCRIPT IS OFF */
#rpliscrollticker {display:none;}
/* THE OUTER DIV */
.tickercontainer {/*border: 1px solid #000;*/background: #fff;width: 100%;height: 27px;margin: 0;padding: 0;overflow:hidden;}
/* SERVES AS A MASK. SO YOU GET A SORT OF PADDING BOTH LEFT AND RIGHT */
.tickercontainer .mask { position: relative;left: 10px;top: 8px;width: 98%;overflow: hidden;}
/* THAT'S YOUR LIST */
ul.newsticker {position: relative;left: 950px;font: bold 10px Verdana;list-style-type: none;margin: 0;padding: 0;}
/* IMPORTANT: DISPLAY INLINE GIVES INCORRECT RESULTS WHEN YOU CHECK FOR ELEM'S WIDTH */
ul.newsticker li {float: left; margin: 0;padding: 0;background: #fff;}
ul.newsticker a {white-space: nowrap;padding: 0;color: #ff0000;font: bold 10px Verdana;margin: 0 50px 0 0;}
ul.newsticker span {margin: 0 10px 0 0;}
EOT;
    $explicitcontent ='';

    $options_dafault = array(
        'category_ids'      => '',
        'post_limit'        => 5,
        'css'               => $css,
        'explicitcontent'   => $explicitcontent,
        'usage_type'        => 1,
    );

    $usage_options = array(
        1 => array('label' => __('from categories')),
        2 => array('label' => __('from categories, randomized')),
        3 => array('label' => __('explicit content')),
        4 => array('label' => __('explicit content, randomized')),
        5 => array('label' => __('both in randomized order')),
        6 => array('label' => __('from categories, explicit content')),
        7 => array('label' => __('explicit content, from categories')),
    );

    $options = get_option("widget_rpliscrollticker");

    if (!is_array($options)) {
        $options = $options_dafault;
    }
    if (isset($_POST['rpliscrollticker-Submit'])) {
        $options['category_ids']    = !isset($_POST['rpliscrollticker-category_ids'])
            ? '' : trim(strval($_POST['rpliscrollticker-category_ids']));
        $options['post_limit']      = !isset($_POST['rpliscrollticker-post_limit']) || !intval($_POST['rpliscrollticker-post_limit'])
            ? 5 : intval($_POST['rpliscrollticker-post_limit']);
        $options['css']             = !isset($_POST['rpliscrollticker-css'])
            ? $css : trim(stripslashes($_POST['rpliscrollticker-css']));
        $options['explicitcontent'] = !isset($_POST['rpliscrollticker-explicitcontent'])
            ? $explicitcontent : trim(stripslashes($_POST['rpliscrollticker-explicitcontent']));
        $options['usage_type'] = !isset($_POST['rpliscrollticker-usage_type'])
            ? $usage_type : intval($_POST['rpliscrollticker-usage_type']);
        if(isset($_POST['rpliscrollticker-reset'])){
            $options = $options_dafault;
        }
        update_option("widget_rpliscrollticker", $options);
    }
?>
    <input type="hidden" id="rpliscrollticker-Submit" name="rpliscrollticker-Submit" value="1" />
    <p>
        <label for="rpliscrollticker-category_ids"><?php _e('Category IDs (comma separated)','rp-news-ticker') ?>:<br />
        <input type="text" id="rpliscrollticker-category_ids" name="rpliscrollticker-category_ids"
            style="width:98%;" size="25" value="<?php echo !isset($options['category_ids']) ? '' : $options['category_ids']; ?>" /></label><br />
        <small><?php echo _e('Leave empty for all categories.','rp-news-ticker'); ?></small>
    </p>
    <p>
    <label for="rpliscrollticker-post_limit"><?php _e('Limit Latest Posts','rp-news-ticker') ?>:
    <input type="text" id="rpliscrollticker-post_limit" name="rpliscrollticker-post_limit"
            value="<?php echo !isset($options['post_limit']) ? 5 : $options['post_limit']; ?>"
                                            maxlength="2" size="2" style="text-align:right" /></label>
    </p>
    <p>
    <label for="rpliscrollticker-css"><?php _e('Scroller Styles','rp-news-ticker') ?>:<br />
    <textarea wrap="off" cols="22" rows="5" id="rpliscrollticker-css" name="rpliscrollticker-css"
            style="width:98%;font-size:smaller;font-family:monotype;"><?php echo !isset($options['css']) ? $css : $options['css']; ?></textarea></label>
    </p>
    <p>
    <label for="rpliscrollticker-explicitcontent"><?php _e('Explicit Content','rp-news-ticker') ?>:<br />
    <textarea wrap="off" cols="22" rows="5" id="rpliscrollticker-explicitcontent" name="rpliscrollticker-explicitcontent"
            style="width:98%;font-size:smaller;font-family:monotype;"><?php echo !isset($options['explicitcontent']) ? $explicitcontent
                : $options['explicitcontent']; ?></textarea></label>
        <small>
            <?php echo _e('When this field is non-empty, the scroller tries to use <strong>li</strong> elements from it.','rp-news-ticker'); ?>
            <?php echo _e('Best understood format for the content is:','rp-news-ticker'); ?>
             <em>&lt;li&gt;&lt;span&gt;<?php echo _e('something','rp-news-ticker'); ?>&lt;/span&gt;&lt;a href="<?php echo _e('something','rp-news-ticker');
                        ?>"&gt;<?php echo _e('something','rp-news-ticker'); ?>&lt;/a&gt;&lt;/li&gt;</em>
        </small>
    </p>
    <p>
    <label for="rpliscrollticker-usage_type"><?php _e('Usage Type','rp-news-ticker') ?>:
        <select id="rpliscrollticker-usage_type" name="rpliscrollticker-usage_type" >
            <?php foreach ($usage_options as $k => $v): ?>
                <option value="<?php echo $k; ?>"<?php echo $k == $options['usage_type'] ? ' selected="selected"' : '';
                        ?>><?php echo $v['label']; ?></option>
            <?php endforeach; ?>
        </select>
    </label>
    </p>
    <p>
    <label for="rpliscrollticker-reset"><?php _e('Reset all settings to default','rp-news-ticker') ?>:
        <input type="checkbox" id="rpliscrollticker-reset" name="rpliscrollticker-reset" /></label>
    </p>
<?php
}

function rpliscrollticker_wp_head() {
    $options = get_option("widget_rpliscrollticker");
	?>
<!-- rp news ticker support --><style><?php echo !isset($options['css']) ? '' : rp_compact_css($options['css']); ?></style><script type="text/javascript">
//<![CDATA[
jQuery(document).ready(function($) {$("#rpliscrollticker").show().liScroll({travelocity: 0.04});});
//]]>
</script><!-- /rp news ticker support -->
	<?php
}

add_action('plugins_loaded', 'rpliscrollticker_init');
?>